
Opt( "OnExitFunc", "MakeWindowsOpaque" )

Dim $iDelay = 250
Global $sActiveWin = GetActiveWindow( $iDelay )

Global $aWindowList = GetWindowList()
Dim $iTransparency = 100

MakeWindowsTransparent( $aWindowList )

AdlibEnable ( "CheckActiveWindow", $iDelay )

While 1
    Sleep( $iDelay * 25 )
Wend

Exit

; =========== Subroutines ===========

; Check to see if the current active window is the same as the last time we checked.
; If not, then change the focus (transparent/opaque) to the current active window &
; change the value of "$sActiveWin" to the current active window.
; If it is, then do nothing.
Func CheckActiveWindow()
    If( NOT WinActive( $sActiveWin ) ) Then
        $aWindowList = GetWindowList()
        Local $sCurrentActiveWin = WinGetTitle( "" )
; Local $Msg = 'Current Active Window	= "' & $sCurrentActiveWin &@LF&@LF
; For $I = 1 to $aWindowList[0][0]
; 	$Msg = $Msg & '['&$I&']	= "'&$aWindowList[$I][0]&'"'&@LF
; Next
; Local $RetCode = MsgBox( 4, "Debug", $Msg )
; If( $RetCode = 6 ) Then
; 	Exit
; EndIf
	WinSetTrans( $sActiveWin, "", $iTransparency )
	WinSetTrans( $sCurrentActiveWin, "", 255 )
	WinActivate( $sCurrentActiveWin )
	$sActiveWin = $sCurrentActiveWin
    EndIf
    AdlibEnable ( "CheckActiveWindow", $iDelay )
EndFunc

; Wait until a window besides the "Program Manager" (desktop) is active.
Func GetActiveWindow( $iDelay )
    Local $sActiveWin = ""
    do
        Sleep( $iDelay )
        $sActiveWin = WinGetTitle("")
    Until( $sActiveWin <> "" AND $sActiveWin <> "Program Manager" )
    Return( $sActiveWin )
EndFunc

; Check to see if a window is visible or hidden (minimized windows are also considered visible).
Func IsVisible($handle)
    If BitAnd( WinGetState($handle), 2 ) Then
        Return 1
    Else
        Return 0
    EndIf
EndFunc	; ==> IsVisible()

; Check to see if a window is Minimized or not.
Func IsMinimized($handle)
    If BitAnd( WinGetState($handle), 16 ) Then
        Return 1
    Else
        Return 0
    EndIf
EndFunc  ; ==> IsMinimized()

; Get list of all visible, non-minimized, & non-NULL title windows.
Func GetWindowList()
    ; Get all window titles & handles.
    Local $aAllWindows = WinList()

    ; Make an array the same size as the $aAllWindows array.
    Dim $aWinList[UBound($aAllWindows,1)][UBound($aAllWindows,2)]

    Dim $J = 1
    ; Find & save info. about all windows that aren't NULL titled, visible, and not minimized.
    For $i = 1 to $aAllWindows[0][0]
        Select
        Case( $aAllWindows[$i][0] = "" )
            ContinueLoop
        Case( NOT IsVisible( $aAllWindows[$i][1] ) )
            ContinueLoop
        Case( IsMinimized( $aAllWindows[$i][1] ) )
            ContinueLoop
        EndSelect
        $aWinList[$J][0] = $aAllWindows[$i][0]
        $aWinList[$J][1] = $aAllWindows[$i][1]
        $J = $J + 1
    Next
    ; Put the resulting # of windows into the beginnnig of the array.
    $aWinList[0][0] = $J
    ; Resize the array to conserve RAM.
    ReDim $aWinList[$J+1][2]

    Return( $aWinList )
EndFunc ; ==> MakeWindowList()

; Make all visible & non-minimized windows except active window semi-transparent.
Func MakeWindowsTransparent( $aWinList, $iPTransparency = 85, $iTransparency = 112 )
    For $i = 1 to $aWinList[0][0]
	Select
	Case( $aWinList[$i][0] = $sActiveWin )
	    ContinueLoop
	Case( $aWinList[$i][0] = "Program Manager" )
	    WinSetTrans( $aWinList[$i][0], "", $iPTransparency )
	Case Else
	    ; Make the Window semi-transparent.
	    WinSetTrans( $aWinList[$i][0], "", $iTransparency )
	EndSelect
    Next
EndFunc ; ==> MakeWindowsTransparent()

; Make all Windows opaque.
Func MakeWindowsOpaque()
    AdLibDisable()
    Local $aWinList = GetWindowList()
    For $i = 1 to $aWinList[0][0]
	Select
	Case( $aWinList[$i][0] = "" )
	    ContinueLoop
	EndSelect
	WinSetTrans( $aWinList[$i][0], "", 255 )
    Next
EndFunc ; ==> MakeWindowsOpaque()

